"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Transaction_1 = require("./Transaction");
class Exec {
    static exec(conn, sql) {
        return new Promise((resolve, reject) => {
            conn.query(sql, (err, result) => {
                if (err) {
                    reject(err);
                }
                else {
                    resolve();
                }
            });
        });
    }
    static async execs(conn, sqls) {
        let promiseList = new Array();
        sqls.map(sql => {
            promiseList.push(Exec.exec(conn, sql));
        });
        return Promise.all(promiseList);
    }
    static async execsSeq(conn, sqls) {
        for (let sql of sqls) {
            await Exec.exec(conn, sql);
        }
    }
    static async execsSeqWithTran(conn, sqls) {
        try {
            await Transaction_1.Transaction.begin(conn);
            for (let sql of sqls) {
                await Exec.exec(conn, sql);
            }
            await Transaction_1.Transaction.commit(conn);
            return Promise.resolve();
        }
        catch (err) {
            await Transaction_1.Transaction.rollback(conn);
            return Promise.reject(err);
        }
    }
}
exports.Exec = Exec;
//# sourceMappingURL=Exec.js.map